package com.jd.ai.asr.demo;

import android.content.pm.PackageManager;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.support.v7.app.AppCompatActivity;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by liujunjie10 on 2018/6/6.
 */

public class BaseActivity extends AppCompatActivity {

    private static final int PERMISSION_REQUESTCODE = 100;
    private PermissionListener mListener;

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    public void requetPermission(String[] permissions, PermissionListener listener){
        this.mListener = listener;
        List<String>  mList = new ArrayList<>();
        for(String permission : permissions){
            if(ContextCompat.checkSelfPermission(this,permission) != PackageManager.PERMISSION_GRANTED) {
                mList.add(permission);
            }
        }

        if(!mList.isEmpty()) {
            ActivityCompat.requestPermissions(this,mList.toArray(new String[mList.size()]),PERMISSION_REQUESTCODE);
        }else {
            mListener.onSuccess();
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        switch (requestCode) {
            case PERMISSION_REQUESTCODE:
             if(grantResults.length > 0){
                 List<String> deiedPermissions = new ArrayList<>();
                 for(int i=0;i<grantResults.length;i++){
                     int grantResult = grantResults[i];
                     String permission = permissions[i];
                     if(grantResult!= PackageManager.PERMISSION_GRANTED){
                         deiedPermissions.add(permission);
                     }
                 }
                 if(deiedPermissions.isEmpty()){
                     mListener.onSuccess();
                 }else {
                     mListener.onFail(deiedPermissions);
                 }
             }
        }
    }

    public interface  PermissionListener {
        void  onSuccess();
        void onFail(List<String> deiedPermission);
    }
}
